<template>
  <v-container fluid>
    <v-row>
      <template v-for="(item, i) in allOrders">
        <v-col :key="i" v-if="item.estado !== '5'">
          <v-card class="mx-1 my-6" max-width="500" min-width="400">
            <v-row>
              <v-col>
                <v-img
                  max-width="300"
                  max-height="300"
                  :src="item.producto[0].imagen"
                  class="mx-auto"
                ></v-img>
              </v-col>
            </v-row>
            <v-card-title>{{ item.producto[0].descripcion }}</v-card-title>
            <v-card-text>
              <div class="text-overline">DATOS DEL PRODUCTO</div>
              <v-divider></v-divider>
            </v-card-text>
            <v-list-item ripple>
              <v-list-item-content>
                <v-list-item-subtitle>ASIN</v-list-item-subtitle>
                <v-list-item-title>{{ item.asin }}</v-list-item-title>
              </v-list-item-content>
            </v-list-item>
            <v-list-item ripple>
              <v-list-item-content>
                <v-list-item-subtitle>Cantidad</v-list-item-subtitle>
                <v-list-item-title>{{ item.cantidad }}</v-list-item-title>
              </v-list-item-content>
            </v-list-item>
            <v-row no-gutters>
              <v-col>
                <v-list-item ripple>
                  <v-list-item-content>
                    <v-list-item-subtitle
                      >Unidad de Medida</v-list-item-subtitle
                    >
                    <v-list-item-title>{{ item.unidad }}</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-col>
              <v-col>
                <v-list-item ripple>
                  <v-list-item-content>
                    <v-list-item-subtitle>Peso</v-list-item-subtitle>
                    <v-list-item-title>{{ item.peso }}</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-col>
            </v-row>
            <v-row no-gutters>
              <v-col>
                <v-list-item ripple>
                  <v-list-item-content>
                    <v-list-item-subtitle>Categoría</v-list-item-subtitle>
                    <v-list-item-title>{{ item.categoria }}</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-col>
              <v-col>
                <v-list-item ripple>
                  <v-list-item-content>
                    <v-list-item-subtitle>Empaque</v-list-item-subtitle>
                    <v-list-item-title>{{ item.paquete }}</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-col>
            </v-row>
            <v-card-text>
              <div class="text-overline">DATOS DE LA COMPRA</div>
              <v-divider></v-divider>
            </v-card-text>
            <v-row no-gutters>
              <v-col>
                <v-list-item ripple>
                  <v-list-item-content>
                    <v-list-item-subtitle>Origen</v-list-item-subtitle>
                    <v-list-item-title>{{ item.origen }}</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-col>
              <v-col>
                <v-list-item ripple>
                  <v-list-item-content>
                    <v-list-item-subtitle>Destino</v-list-item-subtitle>
                    <v-list-item-title>{{ item.destino }}</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-col>
            </v-row>
            <v-list-item ripple>
              <v-list-item-content>
                <v-list-item-subtitle>Total de la Compra</v-list-item-subtitle>
                <v-list-item-title>{{
                  parseFloat(item.total).toFixed(2)
                }}</v-list-item-title>
              </v-list-item-content>
            </v-list-item>
            <v-list-item ripple>
              <v-list-item-content>
                <v-list-item-subtitle>Estado de la compra</v-list-item-subtitle>
                <template v-for="(itemState, i) in listOrdersState">
                  <v-list-item-title
                    :key="i"
                    v-if="parseInt(item.estado) === itemState.idState"
                    >{{ itemState.description }}</v-list-item-title
                  >
                </template>
              </v-list-item-content>
            </v-list-item>
            <v-divider class="mx-4"></v-divider>
            <v-card-actions>
              <v-btn
                color="deep-purple lighten-2"
                text
                @click="showModal(item)"
              >
                Editar
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
      </template>
    </v-row>
    <v-dialog v-model="modalUpdate" persistent max-width="400px">
      <v-card>
        <v-card-title>
          <p class="text-h5" style="word-break: break-word">{{ titleEdit }}</p>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col>
                <v-select
                  :items="ordersState"
                  label="Estado de la compra"
                  v-model="orderState"
                  item-text="description"
                  item-value="idState"
                  return-object
                  required
                ></v-select>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            :disabled="btnCancelar"
            text
            @click="hiddeModal"
          >
            Cerrar
          </v-btn>
          <v-btn
            color="blue darken-1"
            :disabled="btnRegistro"
            text
            @click="actualizar"
          >
            Guardar
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script lang="ts">
import { Vue, Component, getModule } from 'nuxt-property-decorator'
import AllOrders from '@/store/orders'
import OrderState from '@/store/orderState'
import MisOrdenesState from '@/store/misordenes'

@Component({
  name: 'ordenes',
})
export default class Ordenes extends Vue {
  modalUpdate: boolean = false
  btnCerrarModalUpdate: boolean = false
  btnCancelar: boolean = false
  btnRegistro: boolean = false
  orden: any = {
    arancel: '',
    asin: '',
    cantidad: '',
    categoria: '',
    descuento: '',
    destino: '',
    estado: '',
    flete: '',
    id: '',
    impuesto: '',
    origen: '',
    paquete: '',
    peso: '',
    precioTotal: '',
    producto: '',
    subTotal: '',
    total: '',
    unidad: '',
    usuario: '',
  }

  ordersState = [{ idState: 1, description: 'Pendiente de revisión' }]

  orderState = { idState: -1, description: '' }

  showModal(item: any) {
    this.modalUpdate = true
    this.orden = Object.assign({}, item)
    this.orderState = { idState: parseInt(this.orden.estado), description: '' }
  }

  actualizar() {
    this.orden.estado = this.orderState.idState
    const upd = getModule(MisOrdenesState, this.$store)
    upd.updateQuotation(this.orden).then((e) => {
      this.modalUpdate = false
      this.AllOrders()
      this.orderState = { idState: -1, description: '' }
    })
  }

  get titleEdit() {
    return this.orden.producto[0]?.descripcion.split(',')[0]
  }

  get allOrders() {
    const orders = getModule(AllOrders, this.$store)
    return orders.allOrdersGetter
  }

  get listOrdersState() {
    const orders = getModule(OrderState, this.$store)
    return orders.listOrderStateGetter
  }

  AllOrders() {
    const allOrders = getModule(AllOrders, this.$store)
    allOrders.getAllOrders().then((res) => {})
  }

  listOrderState() {
    const orders = getModule(OrderState, this.$store)
    orders.getOrderState().then((e) => {
      this.ordersState = e
    })
  }

  hiddeModal() {
    this.modalUpdate = false
    this.orderState = { idState: -1, description: '' }
  }

  created() {
    this.AllOrders()
    this.listOrderState()
  }
}
</script>